//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers  8
#property indicator_color1   clrDeepSkyBlue
#property indicator_color2   clrDarkGray
#property indicator_color3   clrSandyBrown
#property indicator_color4   clrDarkGray
#property indicator_color5   clrDeepSkyBlue
#property indicator_color6   clrDeepSkyBlue
#property indicator_color7   clrSandyBrown
#property indicator_color8   clrSandyBrown
#property indicator_width5   3
#property indicator_width6   3
#property indicator_width7   3
#property indicator_width8   3
#property indicator_style1   STYLE_DOT
#property indicator_style2   STYLE_DOT
#property indicator_style3   STYLE_DOT
#property indicator_minimum -1
#property indicator_maximum  1
#property strict
#property strict

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_tbiased2,   // Trend biased (extreme) price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased,  // Heiken ashi trend biased price
   pr_hatbiased2  // Heiken ashi trend biased (extreme) price
};
enum enMaTypes
{
   avg_sma,    // Simple moving average
   avg_ema,    // Exponential moving average
   avg_smma,   // Smoothed moving average
   avg_lwma    // Linear weighted moving average
};
enum enCorrType
{
   cor_spe,  // Spearman rank correlation
   cor_pea   // Pearson rank correlation
};
extern ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT; // Time frame to use
extern int             Rank            = 32;             // Rank
extern enPrices        Price           = pr_close;       // Price to use
extern int             PriceSmooth     = 0;              // Price smoothing (-1 same as rank, 0 no smoothing)
extern enMaTypes       PriceSmoothType = avg_ema;        // Price smoothing type
extern enCorrType      Type            = cor_pea;        // Correlation type
extern int             flPeriod        = 0;              // Floating levels period (<0 use rank period, 0 use fixed levels)
extern double          flLevelUp       = 90;             // Upper level
extern double          flLevelDown     = 10;             // Lower level
extern bool            alertsOn        = false;          // Turn alert on?
extern bool            alertsOnCurrent = true;           // Alerts on current (stil opened) bar?
extern bool            alertsMessage   = true;           // Alerts should display alert message?
extern bool            alertsSound     = false;          // Alerts should play a sound?
extern bool            alertsEmail     = false;          // Alerts should send email?
extern bool            Interpolate     = true;           // Interpolate in mult time frame mode?

//
//
//
//
//

double rank[];
double rankUa[];
double rankUb[];
double rankDa[];
double rankDb[];
double trend[],levelup[],levelmi[],leveldn[];;

string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(9);          
   SetIndexBuffer(0, levelup);
   SetIndexBuffer(1, levelmi);
   SetIndexBuffer(2, leveldn);
   SetIndexBuffer(3, rank);
   SetIndexBuffer(4, rankUa);
   SetIndexBuffer(5, rankUb);
   SetIndexBuffer(6, rankDa);
   SetIndexBuffer(7, rankDb);
   SetIndexBuffer(8, trend);
   
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);

      string add = (Type==cor_pea) ? " Pearson (" : " Spearman (";
   IndicatorShortName(timeFrameToString(TimeFrame)+add+(string)Rank+","+(string)PriceSmooth+", levels period : "+(string)flPeriod+")");
   return(0);
}
int deinit() { return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { levelup[0] = MathMin(limit+1,Bars-1); return(0); }
         if (TimeFrame != _Period)
         {
            limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));
            for (int i=limit;i>=0;i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
                  levelup[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Rank,Price,PriceSmooth,PriceSmoothType,Type,flPeriod,flLevelUp,flLevelDown,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
                  levelmi[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Rank,Price,PriceSmooth,PriceSmoothType,Type,flPeriod,flLevelUp,flLevelDown,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,1,y);
                  leveldn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Rank,Price,PriceSmooth,PriceSmoothType,Type,flPeriod,flLevelUp,flLevelDown,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,2,y);
                  rank[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Rank,Price,PriceSmooth,PriceSmoothType,Type,flPeriod,flLevelUp,flLevelDown,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,3,y);
                  trend[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Rank,Price,PriceSmooth,PriceSmoothType,Type,flPeriod,flLevelUp,flLevelDown,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,8,y);
                  rankUa[i]  = EMPTY_VALUE;
                  rankUb[i]  = EMPTY_VALUE;
                  rankDa[i]  = EMPTY_VALUE;
                  rankDb[i]  = EMPTY_VALUE;

                  //
                  //
                  //
                  //
                  //
      
                  if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

                     int n,k; datetime time = iTime(NULL,TimeFrame,y);
                        for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                        for(k = 1; i+n < Bars && i+k < Bars && k<n; k++)
                        {
                           levelup[i+k] = levelup[i] + (levelup[i+n]-levelup[i])*k/n;
                           levelmi[i+k] = levelmi[i] + (levelmi[i+n]-levelmi[i])*k/n;
                           leveldn[i+k] = leveldn[i] + (leveldn[i+n]-leveldn[i])*k/n;
                           rank[i+k]    = rank[i]    + (rank[i+n]   -rank[i]   )*k/n;
                        }               
            }
            for (int i=limit;i>=0;i--)
            {
               if (trend[i]== 1) PlotPoint(i,rankUa,rankUb,rank);
               if (trend[i]==-1) PlotPoint(i,rankDa,rankDb,rank);
            }
            return(0);
         }            

   //
   //
   //
   //
   //

   int flperiod = flPeriod;    if (flperiod<0) flperiod = Rank;
   int avperiod = PriceSmooth; if (avperiod<0) avperiod = Rank;
   if (trend[limit]== 1) CleanPoint(limit,rankUa,rankUb);
   if (trend[limit]==-1) CleanPoint(limit,rankDa,rankDb);
   for(int i = limit; i >= 0; i--)
   {
      double price = iCustomMa(PriceSmoothType,getPrice(Price,Open,Close,High,Low,i,Bars),avperiod,i);
      rankUa[i] = EMPTY_VALUE;
      rankUb[i] = EMPTY_VALUE;
      rankDa[i] = EMPTY_VALUE;
      rankDb[i] = EMPTY_VALUE;
        if (Type==cor_spe)
               rank[i]  = iSpearman(price,Rank,i,Bars);
         else  rank[i]  = iPearson(price,Rank,i,Bars);
         if (flperiod>0)
         {
            double min = rank[ArrayMinimum(rank,flperiod,i)];
            double max = rank[ArrayMaximum(rank,flperiod,i)];
            double range = max-min;
               levelmi[i] = min+range*0.5;
               levelup[i] = min+range*flLevelUp/100.0;
               leveldn[i] = min+range*flLevelDown/100.0;
         }     
         else
         {
               levelup[i] = 2*flLevelUp  /100.0-1; 
               leveldn[i] = 2*flLevelDown/100.0-1; 
               levelmi[i] = (levelup[i]+leveldn[i])*0.5;
         }       
         trend[i] = (rank[i]>levelup[i]) ? 1 : (rank[i]<leveldn[i]) ? -1 : 0;
         if (trend[i] ==  1) PlotPoint(i,rankUa,rankUb,rank);
         if (trend[i] == -1) PlotPoint(i,rankDa,rankDb,rank);
      }      
      manageAlerts();
      return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

#define pearsonInstances 1
double workPearson[][pearsonInstances];
double iPearson(double value, int period, int i, int bars, int instanceNo=0)
{
   if (ArrayRange(workPearson,0)!=bars) ArrayResize(workPearson,bars); i=bars-i-1; workPearson[i][instanceNo]=value;
   
   //
   //
   //
   //
   //
   
   double SumXY=0; double SumXX=0; double SumYY=0; double SumY=0; double SumX=0;         
   for(int k=0; k<period && (i-k)>=0; k++)
   {
      double val = workPearson[i-k][instanceNo];
             SumX  += val;  
             SumY  += k;  
             SumXX += val*val;
             SumYY += k*k;         
             SumXY += val*k; 
   }
   double SXY    =  period*SumXY-SumY*SumX; 
   double SXXYY  = (period*SumXX-SumX*SumX)*(period*SumYY-SumY*SumY);
   double result = (SXXYY!=0) ? -SXY/(MathSqrt(MathAbs(SXXYY))) : 0;
   return(result);
}

//
//
//
//
//

#define spearmanInstances 1
double workSpearman[][spearmanInstances];
double iSpearman(double value, int period, int i, int bars, int instanceNo=0)
{
   if (ArrayRange(workSpearman,0)!=bars) ArrayResize(workSpearman,bars); i=bars-i-1; workSpearman[i][instanceNo]=value;

   //
   //
   //
   //
   //
      
   double total=0; 
   double data[]; ArrayResize(data, period); ArrayInitialize(data,0);
      for (int k=0; k<period && (i-k)>=0; k++) data[k] = workSpearman[i-k][instanceNo];
      for (int k=0; k<period; k++) { int max = ArrayMaximum(data); total += (max-k)*(max-k); data[max] = 0; }
	return(1.0-6.0*total/(period*(period*period-1.0)));
}


//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

#define _maInstances 1
#define _maWorkBufferx1 1*_maInstances
#define _maWorkBufferx2 2*_maInstances

string averageName(int mode)
{
   switch (mode)
   {
      case avg_sma   : return("SMA");
      case avg_ema   : return("EMA");
      case avg_smma  : return("SMMA");
      case avg_lwma  : return("LWMA");
   }
   return("");
}
double iCustomMa(int mode, double price, double length, int r, int instanceNo=0)
{
   r = Bars-r-1;
   switch (mode)
   {
      case avg_sma   : return(iSma(price,(int)length,r,instanceNo));
      case avg_ema   : return(iEma(price,length,r,instanceNo));
      case avg_smma  : return(iSmma(price,length,r,instanceNo));
      case avg_lwma  : return(iLwma(price,(int)length,r,instanceNo));
      default       : return(price);
   }
}

//
//
//
//
//

double workSma[][_maWorkBufferx2];
double iSma(double price, int period, int r, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(workSma,0)!= Bars) ArrayResize(workSma,Bars); instanceNo *= 2; int k;

   //
   //
   //
   //
   //
      
   workSma[r][instanceNo+0] = price;
   workSma[r][instanceNo+1] = price; for(k=1; k<period && (r-k)>=0; k++) workSma[r][instanceNo+1] += workSma[r-k][instanceNo+0];  
   workSma[r][instanceNo+1] /= 1.0*k;
   return(workSma[r][instanceNo+1]);
}

//
//
//
//
//

double workEma[][_maWorkBufferx1];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars);

   //
   //
   //
   //
   //
      
   workEma[r][instanceNo] = price;
   double alpha = 2.0 / (1.0+period);
   if (r>0)
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//
//
//
//
//

double workSmma[][_maWorkBufferx1];
double iSmma(double price, double period, int r, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(workSmma,0)!= Bars) ArrayResize(workSmma,Bars);

   //
   //
   //
   //
   //

   if (r<period)
         workSmma[r][instanceNo] = price;
   else  workSmma[r][instanceNo] = workSmma[r-1][instanceNo]+(price-workSmma[r-1][instanceNo])/period;
   return(workSmma[r][instanceNo]);
}

//
//
//
//
//

double workLwma[][_maWorkBufferx1];
double iLwma(double price, double period, int r, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(workLwma,0)!= Bars) ArrayResize(workLwma,Bars);
   
   //
   //
   //
   //
   //
   
   workLwma[r][instanceNo] = price;
      double sumw = period;
      double sum  = period*price;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = period-k;
                sumw  += weight;
                sum   += weight*workLwma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar]   ==  1) doAlert(whichBar,DoubleToStr(flLevelUp  ,2)+" broken up");
         if (trend[whichBar]   == -1) doAlert(whichBar,DoubleToStr(flLevelDown,2)+" broken down");
         if (trend[whichBar+1] == -1) doAlert(whichBar,DoubleToStr(flLevelDown,2)+" broken up");
         if (trend[whichBar+1] ==  1) doAlert(whichBar,DoubleToStr(flLevelUp  ,2)+" broken down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       string add = (Type==cor_pea) ? "Pearson " : " Spearman ";
       message = _Symbol+" "+timeFrameToString(_Period)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+add+" level "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(_Symbol+add+" rank",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>Bars-2) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>Bars-3) return;
   if (first[i+1] == EMPTY_VALUE)
         if (first[i+2] == EMPTY_VALUE) 
               { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
         else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else        { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

#define priceInstances 1
double workHa[][priceInstances*4];
double getPrice(int tprice, const double& open[], const double& close[], const double& high[], const double& low[], int i, int bars, int instanceNo=0)
{
  if (tprice>=pr_haclose)
   {
      if (ArrayRange(workHa,0)!= bars) ArrayResize(workHa,bars); instanceNo*=4;
         int r = bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (tprice)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
            case pr_hatbiased2:
               if (haClose>haOpen)  return(haHigh);
               if (haClose<haOpen)  return(haLow);
                                    return(haClose);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (tprice)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
      case pr_tbiased2:   
               if (close[i]>open[i]) return(high[i]);
               if (close[i]<open[i]) return(low[i]);
                                     return(close[i]);        
   }
   return(0);
}   